variables:
  CMAKE_CXX_FLAGS: "-Werror"
  CMAKE_C_FLAGS: "-Werror"

stages:
  - build-entities
  - checks
  - documentation

default:
  image: espressif/idf:release-v4.4

build-entities:
  stage: build-entities
  script:
    - cd $ENTITY
    - echo $TERM
    - pwd
    - idf.py build
  parallel:
    matrix:
      - ENTITY: branch
      - ENTITY: data_center
      - ENTITY: ec_station
      - ENTITY: factory
      - ENTITY: hospital
      - ENTITY: house
      - ENTITY: power_plant
      - ENTITY: skyscraper
      - ENTITY: solar_farm
      - ENTITY: stadium
      - ENTITY: substation
      - ENTITY: supermarket
      - ENTITY: wind_farm

fmt:
  image: xianpengshen/clang-tools:13
  stage: checks
  script:
    - find \( -name \*.c -o -name \*.h \) ! -path ".git" ! -path '*/build/*' -print0 | xargs -0 -n 1 clang-format --Werror -n -fcolor-diagnostics
  needs: []
  allow_failure: true


pages:
  image: greenbone/doxygen
  script:
  - doxygen util/Doxyfile
  - rm -rf public
  - mv html/ public/
  stage: documentation
  artifacts:
    paths:
    - public
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH

